/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.awk.builtin.a;

import java.math.BigInteger;

import net.morilib.awk.builtin.AwkBinaryArgs;
import net.morilib.awk.io.AwkFiles;
import net.morilib.awk.namespace.AwkNamespace;
import net.morilib.awk.value.AwkArray;
import net.morilib.awk.value.AwkInteger;
import net.morilib.awk.value.AwkValue;

/**
 * 関数a.iotaの記述です。
 *
 *
 * @author MORIGUCHI, Yuichiro 2013/04/13
 */
public class ArrayIota extends AwkBinaryArgs {

	private static final BigInteger P1 = BigInteger.ONE;
	private static final BigInteger M1 = BigInteger.ONE.negate();

	protected ArrayIota() {
		super("iota");
	}

	@Override
	public AwkValue apply(AwkNamespace ns, AwkFiles o, AwkValue a1,
			AwkValue a2) {
		BigInteger a, b;
		AwkArray r;

		a = a1.toInteger();  b = a2.toInteger();
		r = new AwkArray();
		if(a.compareTo(b) < 0) {
			for(BigInteger i = a; i.compareTo(b) <= 0; i = i.add(P1)) {
				r.putArray(i.subtract(a).add(P1).toString(),
						AwkInteger.valueOf(i));
			}
		} else if(a.compareTo(b) > 0) {
			for(BigInteger i = a; i.compareTo(b) >= 0; i = i.add(M1)) {
				r.putArray(i.subtract(a).negate().add(P1).toString(),
						AwkInteger.valueOf(i));
			}
		} else {
			r.putArray("1", AwkInteger.valueOf(a));
		}
		return r;
	}

}
